require 'Xomponent/Element'

module Xomponent
  class Document
    attr_writer :title_content, :head_inner, :style_content, :script_content
    DOCTYPE = '<!DOCTYPE html>'

    def method_missing(name, **args, &block)
      Element.new(name, args, &block)
    end

    def head_content
      title { @title_content } +
      style { @style_content } + (@head_inner || '')
    end

    def render
      DOCTYPE + html {
        head { head_content } +
        body {
          div(id: :app) +
          script { @script_content }
        }
      }
    end
  end
end
