require 'json'

module Xomponent
  class React
    attr_accessor :tag, :body, :params

    def initialize(tag = :div, body = 'null', **params)
      @tag = tag
      @body = body
      @params = params
    end

    def render
      "React.createElement('#{tag}',#{JSON.dump(params)},#{body})"
    end

    def self.render(component, target)
      "ReactDOM.render(#{component.render},#{target});"
    end

    def self.render_to_id(component, id = 'app')
      "ReactDOM.render(#{component.render},document.getElementById('#{id}'));"
    end

    def self.render_to_app(component, id = 'app')
      "ReactDOM.render(#{component.render},document.getElementById('#{id}'));"
    end
  end
end
